#include <qthing>

#include "esp_log.h"
#include "driver/gpio.h"

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"


#include "CyanLight.hpp"
#include "SiliconTorch/FxCyanF.hpp"

#include "SpiderLib/NumberTypes.hpp"


// ### LIBS FOR TESTING ###
#include <cstdlib>
//#include "SpiderLib/SNTP.hpp"
#include "SpiderLib/Util.hpp"

#include "SiliconTorch/CyanBus.hpp"


#include <memory>
#include "driver/gpio.h"
#include "SiliconTorch/FxCyanRGB8.hpp"


//#include "SiliconTorch/FxPublish.hpp"


#include "SiliconTorch/NVSExplorer.hpp"
#include <set>  // remove after NVSExplorer development!

// ###     END LIBS     ###



#include <algorithm>



SiliconTorch::CyanBus::CyanBus* cyanBus = NULL;

//SiliconTorch::FxPublish::FxPublish* fxPub = NULL;
SiliconTorch::FxCyanRGB8::FxCyanRGB8* cyanRGB = NULL;

CyanLight::CyanLightControl* ctrl;



void device_main() {


  qthing::Config cfg;

  // Needed for packet parsing, animation rendering and stuff
  qthing::power_managment_max_power();




  //cyanBus = new SiliconTorch::CyanBus::CyanBus(13, 14, 12, 15, 2000000);  // Pinout of CyanStripe


  /* auto led0 = cfg.add<qthing::leds::WS2812B_V3>(GPIO_NUM_27, 8);

  cyanRGB = new SiliconTorch::FxCyanRGB8::FxCyanRGB8(8);
  cyanRGB->registerUDPHandler();
  cyanRGB->registerAtCyanBus(*cyanBus);

  auto bullshitPtr = std::shared_ptr<qthing::Animation<qthing::RGB>>(cyanRGB, [](void*){});
  cfg.add<qthing::Animator<qthing::RGBW8>>(led0)->setAnimation(bullshitPtr); */

  //fxPub = new SiliconTorch::FxPublish::FxPublish();
  //fxPub->registerAtCyanBus(*cyanBus);



  // TODO: ???


  // Trigger singleton initialization
  SiliconTorch::NVSExplorer::NVSExplorer::instance();


  //std::set<std::string> namespaces = SiliconTorch::NVSExplorer::NVSExplorer::instance().listNamespaces();

  //std::string _ns = SiliconTorch::NVSExplorer::toString(namespaces, " ~=[]=~ ");

  //ESP_LOGW("__SET__", "Listing Namespaces: %s", _ns.c_str());



  ctrl = new CyanLight::CyanLightControl(0);

  // auto fxCyanF = (SiliconTorch::FxCyanF::FxCyanF) *ctrl;
  // SiliconTorch::FxCyanF::configureFromNVS(fxCyanF);

  qthing::enable_wifi();
  return;




  // #############################
  // ### CLC-Drucker init code ###
  // #############################


/*
  ctrl = new CyanLight::CyanLightControl(3);
  
  ctrl->setFrqRes(100, 19);


  for (u8 i = 0; i < 100; i++) {

    bool _f = i % 2 == 0;

    ctrl->setPWM(0,  _f      * 1.0f);
    ctrl->setPWM(2, (_f ^ 1) * 1.0f);

    vTaskDelay(50 / portTICK_PERIOD_MS);
  }


  ctrl->setPWM(0, 0.0f);
  ctrl->setPWM(1, 0.0f);
  ctrl->setPWM(2, 1.0f);


  qthing::enable_wifi();
  cfg.apply();

  return;
*/


  // ### end CLC-Drucker ###
  // #############################






  auto delay = 10 / portTICK_PERIOD_MS;
  float limit = 50.0f;

  while (true) {
    for (u8 i = 0; i < limit; i++) {
      float pwm = i / limit;
      ctrl->setPWM(0, pwm*pwm);
      vTaskDelay(delay);
    }

    for (u8 i = 0; i < limit; i++) {
      float pwm = i / limit;
      ctrl->setPWM(0, 1.0f - pwm*pwm);
      vTaskDelay(delay);
    }
  }
}
